use hittingset::Edge;
use plistore::{Cluster, RowIndex};

use crate::edgecollectors::EdgeConsumer;

pub mod fds;
pub mod fdsunion;
pub mod uccs;
mod common;
pub mod results;

pub trait ProblemConfig {
    type EdgeType : Edge;

    fn get_edge(&self, r1: RowIndex, r2: RowIndex, receiver: &mut impl EdgeConsumer<Self::EdgeType>);
    fn is_valid_result(&self, result: &Self::EdgeType) -> bool;
    fn is_violating_pair(&self, r1: RowIndex, r2: RowIndex, candidate: &Self::EdgeType) -> bool;
}
