#[macro_use]
extern crate derive_builder;

use smallvec::SmallVec;

pub use plis::PLITable;
pub use reader::{CSVConfig, CSVConfigBuilder, read_input};
use refinementhelper::RefinementHelper;

mod plis;
mod reader;
mod refinementhelper;

pub type RowIndex = u32;
pub type Cluster = SmallVec<[RowIndex; 4]>;
pub type ClusterIndex = u32;
pub type Pli = Vec<Cluster>;

pub trait ClusterFilter {
    fn keep(&mut self, cluster: &Cluster) -> bool {
        cluster.len() > 1
    }
    fn set_requested_level(&mut self, active: bool);
}